import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;

/**
 * Write a description of class Space here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Space  extends World
{

    /**
     * Constructor for objects of class Space.
     * 
     */
    public int shot = 1;
    
    public int invaders = 50;
    
    Counter score = new Counter("Score: ");
    
    Counter lives = new Counter("Lives: ");
    
    public Space()
    {    
        // Create a new world with 20x20 cells with a cell size of 10x10 pixels.
        super(100, 100, 5); 
        addObject(new Ship(), 50, 90);
        addObject(new Barrier(), 75, 70);
        addObject(new Barrier(), 50, 70);
        addObject(new Barrier(), 25, 70);
        addObject(score, 15, 90);
        addObject(lives, 95, 90);
        lives.add(3);
        populate();
    }
    
    public void ShootSet(int arg)
    {
        shot = arg;
    }
    
    public boolean CanShoot()
    {
        if (shot == 1) {
            return true;
        } else {
            return false;
        }
    }
    
    public void addPoints(int pts)
    {
        score.add(pts);
    }
    
    public void die()
    {
        lives.subtract(1);
        if (lives.getValue() == 0) {
            gameOver();
        }
         
        addObject(new Ship(), 50, 90);
        shot = 1;
    }
    
    public void gameOver() 
    {
        addObject(new ScoreBoard(score.getValue()), getWidth()/2, getHeight()/2);
        Greenfoot.stop();
    }
    
    public void populate()
    {
        //first row
        Enemy1[] enemies1 = new Enemy1[10];
        for ( int i = 0; i <10; i++ ) {
            enemies1[i] = new Enemy1();
            addObject(enemies1[i], (i*5)+5, 10);
        }
        
        //second row
       Enemy2[] enemies2 = new Enemy2[21];
        for ( int i = 0; i <10; i++ ) {
            enemies2[i] = new Enemy2();
            addObject(enemies2[i], (i*5)+5, 15);
        }
        
        //3rd row
        for ( int i = 11; i <21; i++ ) {
            enemies2[i] = new Enemy2();
            addObject(enemies2[i], ((i*5)+5)-55, 20);
        } 
        //4th row
        Enemy3[] enemies3 = new Enemy3[21];
        for ( int i = 0; i <10; i++ ) {
            enemies3[i] = new Enemy3();
            addObject(enemies3[i], (i*5)+5, 25);
        } 
        //final row
        for ( int i = 11; i <21; i++ ) {
            enemies3[i] = new Enemy3();
            addObject(enemies3[i], ((i*5)+5)-55, 30);
        } 
    }
}
