import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*; //for lists and stuff
/**
 * Write a description of class Ship here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Ship  extends Actor
{
    /**
     * Act - do whatever the Ship wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */  
    private int ShootTimer = 0;
    
    public void act() 
    {
       List bullets = getNeighbours(3, false, Ebullet.class); //new list with all Pbullets within 2 uinits adjacent to the enemy
       if (!bullets.isEmpty()) { //is there is one (there will only be one, since only one bullet on screen at a time)
       Actor b = (Actor) bullets.get(0); //gets the first object in the list
       if (b instanceof Ebullet) { //just an extra check to make sure its a player bullet
           getWorld().removeObject(b); //remobe the bullet
           destroy(); //call the destroy funcrtion
       }
       } else {
        processKeys();
       }
    }    
    
    /**
     * Handle keyboard input.
     */
    private void processKeys() {
        int x = getX();
        if(Greenfoot.isKeyDown("right")) {
            x = x+1;
            setLocation(x, getY());
        }
        if(Greenfoot.isKeyDown("left")) {
            x = x-1;
            setLocation(x, getY());
        }
        if (Greenfoot.isKeyDown("up") && ((Space) getWorld()).CanShoot()) {
            getWorld().addObject(new Pbullet(), getX(), getY()-5);
            ((Space) getWorld()).ShootSet(0);
            Greenfoot.playSound("shoot.wav");
        }   
    }

    private void destroy() {
        getWorld().addObject(new Pdie(), getX(), getY());
        ((Space) getWorld()).ShootSet(0);
        Greenfoot.playSound("explosion.wav");
        getWorld().removeObject(this);
    }
}
